#include <fstream>
#include <vector>
#include <queue>
#include <tuple>
#include <algorithm>
using namespace std;

ifstream fin("festivaluri.in");
ofstream fout("festivaluri.out");

using VI  = vector<int>;
using PI  = pair<int, int>;
using VP  = vector<PI>;
using VVP = vector<VP>;
using VB  = vector<bool>;

const int Inf = 0x3f3f3f3f;
VVP G;
VI d;
VB fest;

int n, p, z, r;

void CitesteGraf();
void Dijkstra(int x, VI& d);
void Rezolva();

int main()
{
	CitesteGraf();
	Dijkstra(z, d);
	Rezolva();
}

void Dijkstra(int x, VI& d)
{
	int y, dist, w;
	d = VI(n + 1, Inf);
	priority_queue<PI, vector<PI>, greater<PI>> Q; // min-HEP
	
	d[x] = 0;
	Q.emplace(0, x); // push
	while (!Q.empty())
	{
		tie(dist, x) = Q.top();
		Q.pop();
		
		if (dist > d[x])
			continue;
			
		for (auto& p : G[x])
		{
			tie(y, w) = p;
			if (d[y] > d[x] + w)
			{
				d[y] = d[x] + w;
				Q.emplace(d[y], y);
			}
		}
	}
}

void Rezolva()
{
	VI df; // distantee minime de la z la festivaluri
	for (int x = 1; x <= n; ++x)
		if (d[x] != Inf && fest[x])
			df.emplace_back(d[x]);
	
	sort(df.begin(), df.end());
	
	int cnt = 0;
	int efort_total = 0;
	for (const int& efort :  df)
		if (efort_total + efort <= p)
		{
			cnt++;
			efort_total += efort;
		}
		else
			break;
	
	fout << cnt;
}

void CitesteGraf()
{
	int m, x, y, w;
	
	fin >> n >> m >> p >> z >> r;
	G = VVP(n + 1);
	fest = VB(n + 1);
	
	while (m--)
	{
		fin >> x >> y >> w;
		G[x].emplace_back(y, w);
	}
	
	for (int i = 1; i <= r; ++i)
	{
		fin >> x;
		fest[x] = true;
	}
}










