#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>
using namespace std;

using VI  = vector<int>;
using VVI = vector<VI>;

const int Inf = 0x3f3f3f3f;
VVI p; // matricea ponderilor
VVI c; // matricea costurilor minime ale drumurilor 


int n, m;

void CitesteGraf();
void Floyd_Warshall();
void Rezolva();

int main()
{
	CitesteGraf();
	Floyd_Warshall();
	Rezolva();
}

void Floyd_Warshall()
{
	for (int k = 1; k <= n; ++k)
		for (int i = 1; i <= n; ++i)
			for (int j = 1; j <= n; ++j)
				if (i != j && c[i][j] > c[i][k] + c[k][j])	
					c[i][j] = c[i][k] + c[k][j];
}

void Rezolva()
{
	int cnt {0};
	
	for (int i = 1; i <= n; ++i)	
		for (int j = 1; j <= n; ++j)
		{
			if (i == j || p[i][j] == Inf) 
				continue;
			if (p[i][j] == c[i][j])
				cnt++;
		}
		
	cout << cnt;
}

void CitesteGraf()
{
	int m, x, y, w;
	
	cin >> n >> m;
	p = VVI(n + 1, VI(n + 1, Inf));
	for (int i = 1; i <= n; ++i)
		p[i][i] = 0;
	
	while (m--)
	{
		cin >> x >> y >> w;
		p[x][y] = w;
	}
	
	c = p;
}










